#ifndef _LINUX_TASKS_H
#define _LINUX_TASKS_H

/*
 * This is the maximum nr of tasks - change it if you need to
 */
 
#ifdef __SMP__
#define NR_CPUS	32		/* Max processors that can be running in SMP */
#else
#define NR_CPUS 1
#endif

#define NR_TASKS	512

#ifdef __MPP__
/* reserve half the tasks for parallel processes on MPP systems */
#define MPP_TASK_BASE (NR_TASKS/2)
#define MPP_NUM_TASKS (NR_TASKS - MPP_TASK_BASE)
#endif

#define MAX_TASKS_PER_USER (NR_TASKS/2)
#define MIN_TASKS_LEFT_FOR_ROOT 4


/*
 * This controls the maximum pid allocated to a process
 */
#define PID_MAX 0x8000

#ifdef __MPP__
/* MPP tasks use the upper half of the pid range */
#define MPP_PID_BASE (PID_MAX/2)
#endif

#endif
